Index: /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp	(revision 642)
@@ -1,21 +1,18 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+  Copyright(c) 2010, 2011 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -27,5 +24,5 @@
 {
     //ctor
-    MaxFilter=12;
+    MaxFilter=-1;
 }
 
@@ -35,26 +32,10 @@
 }
 
+
 bool INDI::FilterWheel::initProperties()
 {
-    DefaultDriver::initProperties();   //  let the base class flesh in what it wants
+    DefaultDriver::initProperties();
 
-    IUFillNumber(&FilterSlotN[0],"FILTER_SLOT_VALUE","Filter","%3.0f",1.0,12.0,1.0,1.0);
-    IUFillNumberVector(&FilterSlotNV,FilterSlotN,1,deviceName(),"FILTER_SLOT","Filter","Main Control",IP_RW,60,IPS_IDLE);
-
-    IUFillText(&FilterNameT[0],"FILTER1","1","");
-    IUFillText(&FilterNameT[1],"FILTER2","2","");
-    IUFillText(&FilterNameT[2],"FILTER3","3","");
-    IUFillText(&FilterNameT[3],"FILTER4","4","");
-    IUFillText(&FilterNameT[4],"FILTER5","5","");
-    IUFillText(&FilterNameT[5],"FILTER6","6","");
-    IUFillText(&FilterNameT[6],"FILTER7","7","");
-    IUFillText(&FilterNameT[7],"FILTER8","8","");
-    IUFillText(&FilterNameT[8],"FILTER9","9","");
-    IUFillText(&FilterNameT[9],"FILTER10","10","");
-    IUFillText(&FilterNameT[10],"FILTER11","11","");
-    IUFillText(&FilterNameT[11],"FILTER12","12","");
-    IUFillTextVector(&FilterNameTV,FilterNameT,12,deviceName(),"FILTER_NAME","Filter","Filters",IP_RW,60,IPS_IDLE);
-
-    return 0;
+    initFilterProperties(deviceName(), FILTER_TAB);
 }
 
@@ -66,6 +47,8 @@
     if(isConnected())
     {
-        defineNumber(&FilterSlotNV);
-        defineText(&FilterNameTV);
+        defineNumber(FilterSlotNP);
+
+        if (GetFilterNames(deviceName(), FILTER_TAB))
+            defineText(FilterNameTP);
     }
     return;
@@ -79,16 +62,20 @@
     if(isConnected())
     {
-        IUFillNumber(&FilterSlotN[0],"FILTER_SLOT_VALUE","Filter","%3.0f",MinFilter,MaxFilter,1.0,CurrentFilter);
-        defineNumber(&FilterSlotNV);
-        IUFillTextVector(&FilterNameTV,FilterNameT,MaxFilter,deviceName(),"FILTER_NAME","Filter","Filters",IP_RW,60,IPS_IDLE);
-        defineText(&FilterNameTV);
-        //LoadFilterNames();
+        initFilterProperties(deviceName(), FILTER_TAB);
+        defineNumber(FilterSlotNP);
+        if (GetFilterNames(deviceName(), FILTER_TAB))
+            defineText(FilterNameTP);
     } else
     {
-        deleteProperty(FilterSlotNV.name);
-        deleteProperty(FilterNameTV.name);
+        deleteProperty(FilterSlotNP->name);
+        deleteProperty(FilterNameTP->name);
     }
 
     return true;
+}
+
+bool INDI::FilterWheel::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
+{
+    return DefaultDriver::ISNewSwitch(dev, name, states, names,n);
 }
 
@@ -97,15 +84,18 @@
     //  first check if it's for our device
     //IDLog("INDI::FilterWheel::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0) {
+    if(strcmp(dev,deviceName())==0)
+    {
         //  This is for our device
         //  Now lets see if it's something we process here
 
-        if(strcmp(name,"FILTER_SLOT")==0) {
-
+        if(strcmp(name,"FILTER_SLOT")==0)
+        {
             int f;
 
             f=-1;
-            for(int x=0; x<n; x++) {
-                if(strcmp(names[x],"FILTER_SLOT_VALUE")==0) {
+            for(int x=0; x<n; x++)
+            {
+                if(strcmp(names[x],"FILTER_SLOT_VALUE")==0)
+                {
                     //  This is the new filter number we are being asked
                     //  to set as active
@@ -114,9 +104,10 @@
             }
 
-            if(f != -1) {
+            if(f != -1)
+            {
                 //IDLog("Filter wheel got a filter slot change\n");
                 //  tell the client we are busy changing the filter
-                FilterSlotNV.s=IPS_BUSY;
-                IDSetNumber(&FilterSlotNV,NULL);
+                FilterSlotNP->s=IPS_BUSY;
+                IDSetNumber(FilterSlotNP,NULL);
                 //  Tell the hardware to change
                 SelectFilter(f);
@@ -136,29 +127,22 @@
     //IDLog("INDI::FilterWheel got %d new text items name %s\n",n,name);
     //  first check if it's for our device
-    if(strcmp(dev,deviceName())==0) {
+    if(strcmp(dev,deviceName())==0)
+    {
         //  This is for our device
         //  Now lets see if it's something we process here
-        if(strcmp(name,FilterNameTV.name)==0) {
-            //  This is our port, so, lets process it
-
-            //  Some clients insist on sending a port
-            //  and they may not be configured for the
-            //  correct port
-            //  If we are already connected
-            //  and running, it makes absolutely no sense
-            //  to accept a new port value
-            //  so lets just lie to them and say
-            //  we did this, but, dont actually change anything
-            //if(Connected) return true;
-
+        if(strcmp(name,FilterNameTP->name)==0)
+        {
             int rc;
             //IDLog("calling update text\n");
-            FilterNameTV.s=IPS_OK;
-            rc=IUUpdateText(&FilterNameTV,texts,names,n);
-            //IDLog("update text returns %d\n",rc);
-            //  Update client display
-            IDSetText(&FilterNameTV,NULL);
-            //SaveConfig();
+            FilterNameTP->s=IPS_OK;
+            rc=IUUpdateText(FilterNameTP,texts,names,n);
 
+            if (SetFilterNames() == true)
+                IDSetText(FilterNameTP,NULL);
+            else
+            {
+                FilterNameTP->s = IPS_ALERT;
+                IDSetText(FilterNameTP, "Error updating names of filters.");
+            }
             //  We processed this one, so, tell the world we did it
             return true;
@@ -170,21 +154,4 @@
 }
 
-int INDI::FilterWheel::SelectFilterDone(int f)
-{
-    //  The hardware has finished changing
-    //  filters
-    FilterSlotN[0].value=f;
-    FilterSlotNV.s=IPS_OK;
-    // Tell the clients we are done, and
-    //  filter is now useable
-    IDSetNumber(&FilterSlotNV,NULL);
-    return 0;
-}
-
-int INDI::FilterWheel::SelectFilter(int)
-{
-    return -1;
-}
-
 int INDI::FilterWheel::QueryFilter()
 {
@@ -193,2 +160,26 @@
 
 
+bool INDI::FilterWheel::SelectFilter(int)
+{
+    return false;
+}
+
+bool INDI::FilterWheel::SetFilterNames()
+{
+    return true;
+}
+
+void INDI::FilterWheel::ISSnoopDevice (XMLEle *root)
+{
+ return;
+}
+
+
+bool INDI::FilterWheel::GetFilterNames(const char *deviceName, const char* groupName)
+{
+    INDI_UNUSED(deviceName);
+    INDI_UNUSED(groupName);
+    return false;
+}
+
+
Index: /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h	(revision 642)
@@ -1,64 +1,58 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+  Copyright(c) 2010, 2011 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
 
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
-*******************************************************************************/
 #ifndef INDI_FILTERWHEEL_H
 #define INDI_FILTERWHEEL_H
 
 #include "defaultdriver.h"
+#include "indifilterinterface.h"
 
-class INDI::FilterWheel: public INDI::DefaultDriver
+/**
+ * \class INDI::FilterWheel
+   \brief Class to provide general functionality of a filter wheel device.
+
+   Developers need to subclass INDI::FilterWheel to implement any driver for filter wheels within INDI.
+
+\author Gerry Rozema, Jasem Mutlaq
+\see INDI::FilterInterface
+*/
+class INDI::FilterWheel: public INDI::DefaultDriver, public INDI::FilterInterface
 {
-    protected:
-    private:
+protected:
 
-    public:
-        FilterWheel();
-        virtual ~FilterWheel();
+    FilterWheel();
+    virtual ~FilterWheel();
 
-        INumberVectorProperty FilterSlotNV;   //  A number vector for filter slot
-        INumber FilterSlotN[1];
-
-        ITextVectorProperty FilterNameTV; //  A text vector that stores out physical port name
-        IText FilterNameT[12];
-
-        int MinFilter;
-        int MaxFilter;
-        int CurrentFilter;
-        int TargetFilter;
-
+public:
 
         virtual bool initProperties();
         virtual bool updateProperties();
         virtual void ISGetProperties (const char *dev);
+        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);      
+        virtual void ISSnoopDevice (XMLEle *root);
 
-        //  Ok, we do need our virtual functions from the base class for processing
-        //  client requests
-        //  We process Numbers and text in a filter wheel
-        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
-        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
-        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n) { return false; }
+   protected:
 
-        virtual int SelectFilter(int);
-        virtual int SelectFilterDone(int);
-        virtual int QueryFilter();
-        //int SaveFilterNames();
-        //int LoadFilterNames();
+    virtual int QueryFilter();
+    virtual bool SelectFilter(int);
+    virtual bool SetFilterNames();
+    virtual bool GetFilterNames(const char *deviceName, const char* groupName);
 
 };
Index: /BAORadio/libindi/libindi/libs/indibase/indifocuser.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifocuser.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indifocuser.cpp	(revision 642)
@@ -1,22 +1,20 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+  Copyright(c) 2011 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
 
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
-*******************************************************************************/
 #include "indifocuser.h"
 
@@ -25,10 +23,15 @@
 INDI::Focuser::Focuser()
 {
-    //ctor
+    FocusSpeedNP  = new INumberVectorProperty;
+    FocusTimerNP  = new INumberVectorProperty;
+    FocusMotionSP = new ISwitchVectorProperty;
 }
 
 INDI::Focuser::~Focuser()
 {
-    //dtor
+    delete FocusSpeedNP;
+    delete FocusTimerNP;
+    delete FocusMotionSP;
+
 }
 
@@ -37,14 +40,13 @@
     DefaultDriver::initProperties();   //  let the base class flesh in what it wants
 
-    IUFillNumber(&FocusspeedN[0],"FOCUS_SPEED_VALUE","Focus Speed","%3.0f",0.0,255.0,1.0,255.0);
-    IUFillNumberVector(&FocusspeedNV,FocusspeedN,1,deviceName(),"FOCUS_SPEED","Speed","Main Control",IP_RW,60,IPS_OK);
+    IUFillNumber(&FocusSpeedN[0],"FOCUS_SPEED_VALUE","Focus Speed","%3.0f",0.0,255.0,1.0,255.0);
+    IUFillNumberVector(FocusSpeedNP,FocusSpeedN,1,deviceName(),"FOCUS_SPEED","Speed",MAIN_CONTROL_TAB,IP_RW,60,IPS_OK);
 
-    IUFillNumber(&FocustimerN[0],"FOCUS_TIMER_VALUE","Focus Timer","%4.0f",0.0,1000.0,10.0,1000.0);
-    IUFillNumberVector(&FocustimerNV,FocustimerN,1,deviceName(),"FOCUS_TIMER","Timer","Main Control",IP_RW,60,IPS_OK);
+    IUFillNumber(&FocusTimerN[0],"FOCUS_TIMER_VALUE","Focus Timer","%4.0f",0.0,1000.0,10.0,1000.0);
+    IUFillNumberVector(FocusTimerNP,FocusTimerN,1,deviceName(),"FOCUS_TIMER","Timer",MAIN_CONTROL_TAB,IP_RW,60,IPS_OK);
 
-    IUFillSwitch(&FocusmotionS[0],"FOCUS_INWARD","Focus In",ISS_ON);
-    IUFillSwitch(&FocusmotionS[1],"FOCUS_OUTWARD","Focus Out",ISS_OFF);
-    IUFillSwitchVector(&FocusmotionSV,FocusmotionS,2,deviceName(),"FOCUS_MOTION","Focus Direction","Main Control",IP_RW,ISR_1OFMANY,60,IPS_OK);
-
+    IUFillSwitch(&FocusMotionS[0],"FOCUS_INWARD","Focus In",ISS_ON);
+    IUFillSwitch(&FocusMotionS[1],"FOCUS_OUTWARD","Focus Out",ISS_OFF);
+    IUFillSwitchVector(FocusMotionSP,FocusMotionS,2,deviceName(),"FOCUS_MOTION","Direction",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_OK);
 
     return 0;
@@ -54,5 +56,4 @@
 {
     //  First we let our parent populate
-    IDLog("INDI::Focuser::ISGetProperties %s\n",dev);
     DefaultDriver::ISGetProperties(dev);
 
@@ -65,12 +66,12 @@
     {
         //  Now we add our focusser specific stuff
-        IDDefSwitch(&FocusmotionSV, NULL);
-        IDDefNumber(&FocusspeedNV, NULL);
-        IDDefNumber(&FocustimerNV, NULL);
+        defineSwitch(FocusMotionSP);
+        defineNumber(FocusSpeedNP);
+        defineNumber(FocusTimerNP);
     } else
     {
-        deleteProperty(FocusmotionSV.name);
-        deleteProperty(FocusspeedNV.name);
-        deleteProperty(FocustimerNV.name);
+        deleteProperty(FocusMotionSP->name);
+        deleteProperty(FocusSpeedNP->name);
+        deleteProperty(FocusTimerNP->name);
     }
     return true;
@@ -81,11 +82,12 @@
 {
     //  first check if it's for our device
-    IDLog("INDI::Focuser::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0) {
+    if(strcmp(dev,deviceName())==0)
+    {
         //  This is for our device
         //  Now lets see if it's something we process here
-        if(strcmp(name,"FOCUS_TIMER")==0) {
+        if(strcmp(name,"FOCUS_TIMER")==0)
+        {
             //  Ok, gotta move the focusser now
-            int dir;
+            FocusDirection dir;
             int speed;
             int t;
@@ -93,32 +95,30 @@
             //IDLog(")
             //  first we get all the numbers just sent to us
-            FocustimerNV.s=IPS_OK;
-            IUUpdateNumber(&FocustimerNV,values,names,n);
+            FocusTimerNP->s=IPS_OK;
+            IUUpdateNumber(FocusTimerNP,values,names,n);
 
             //  Now lets find what we need for this move
-            speed=FocusspeedN[0].value;
-            if(FocusmotionS[0].s==ISS_ON) dir=1;
-            else dir=0;
-            t=FocustimerN[0].value;
+            speed=FocusSpeedN[0].value;
+            if(FocusMotionS[0].s==ISS_ON) dir=FOCUS_INWARD;
+            else dir=FOCUS_OUTWARD;
+            t=FocusTimerN[0].value;
 
-            Move(dir,speed,t);
+            if (Move(dir,speed,t) == false)
+                FocusTimerNP->s = IPS_ALERT;
 
-
-            //  Update client display
-            IDSetNumber(&FocustimerNV,NULL);
+            IDSetNumber(FocusTimerNP,NULL);
             return true;
         }
 
 
-        if(strcmp(name,"FOCUS_SPEED")==0) {
-
-
-            FocusspeedNV.s=IPS_OK;
-            IUUpdateNumber(&FocusspeedNV,values,names,n);
+        if(strcmp(name,"FOCUS_SPEED")==0)
+        {
+            FocusSpeedNP->s=IPS_OK;
+            IUUpdateNumber(FocusSpeedNP,values,names,n);
 
 
 
             //  Update client display
-            IDSetNumber(&FocusspeedNV,NULL);
+            IDSetNumber(FocusSpeedNP,NULL);
             return true;
         }
@@ -132,17 +132,15 @@
 bool INDI::Focuser::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
 {
-    IDLog("Enter IsNewSwitch for %s\n",name);
-    //for(int x=0; x<n; x++) {
-    //    IDLog("Switch %s %d\n",names[x],states[x]);
-    //}
 
-    if(strcmp(dev,deviceName())==0) {
+    if(strcmp(dev,deviceName())==0)
+    {
         //  This one is for us
-        if(strcmp(name,"FOCUS_MOTION")==0) {
+        if(strcmp(name,"FOCUS_MOTION")==0)
+        {
             //  client is telling us what to do with focus direction
-            FocusmotionSV.s=IPS_OK;
-            IUUpdateSwitch(&FocusmotionSV,states,names,n);
+            FocusMotionSP->s=IPS_OK;
+            IUUpdateSwitch(FocusMotionSP,states,names,n);
             //  Update client display
-            IDSetSwitch(&FocusmotionSV,NULL);
+            IDSetSwitch(FocusMotionSP,NULL);
 
             return true;
@@ -155,5 +153,15 @@
 }
 
-int INDI::Focuser::Move(int,int,int)
+bool INDI::Focuser::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
+{
+    return DefaultDriver::ISNewText(dev, name, texts, names, n);
+}
+
+void INDI::Focuser::ISSnoopDevice (XMLEle *root)
+{
+ return;
+}
+
+bool INDI::Focuser::Move(FocusDirection dir, int speed, int duration)
 {
     //  This should be a virtual function, because the low level hardware class
@@ -161,5 +169,5 @@
     //  but it's much easier early development if the method actually
     //  exists for now
-    return -1;
+    return false;
 }
 
Index: /BAORadio/libindi/libindi/libs/indibase/indifocuser.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifocuser.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indifocuser.h	(revision 642)
@@ -1,21 +1,18 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+  Copyright(c) 2011 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -25,35 +22,44 @@
 #include "defaultdriver.h"
 
+/**
+ * \class INDI::Focuser
+   \brief Class to provide general functionality of a focuser device.
+
+   Developers need to subclass INDI::Focuser to implement any driver for focusers within INDI.
+
+\author Gerry Rozema
+*/
 class INDI::Focuser : public INDI::DefaultDriver
 {
-
-    protected:
-    private:
-
     public:
         Focuser();
         virtual ~Focuser();
 
-        INumberVectorProperty FocusspeedNV;
-        INumber FocusspeedN[1];
-        ISwitchVectorProperty FocusmotionSV; //  A Switch in the client interface to park the scope
-        ISwitch FocusmotionS[2];
-        INumberVectorProperty FocustimerNV;
-        INumber FocustimerN[1];
-
+        enum FocusDirection { FOCUS_INWARD, FOCUS_OUTWARD };
 
         virtual bool initProperties();
         virtual void ISGetProperties (const char *dev);
-        bool updateProperties();
-
-
-        //  Ok, we do need our virtual functions from the base class for processing
-        //  client requests
-        //  We process Numbers in a focusser
+        virtual bool updateProperties();
         virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
         virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+        virtual void ISSnoopDevice (XMLEle *root);
 
-        //  And here are the virtual functions we will have for easy overrides
-        virtual int Move(int, int, int);
+    protected:
+
+        /** \brief Move the focuser in a particular direction with a specific speed for a finite duration.
+            \param dir Direction of focuser, either FOCUS_INWARD or FOCUS_OUTWARD.
+            \param speed Speed of focuser if supported by the focuser.
+            \param duration The timeout in milliseconds before the focus motion halts.
+            \return True if succssfull, false otherwise.
+        */
+        virtual bool Move(FocusDirection dir, int speed, int duration);
+
+        INumberVectorProperty *FocusSpeedNP;
+        INumber FocusSpeedN[1];
+        ISwitchVectorProperty *FocusMotionSP; //  A Switch in the client interface to park the scope
+        ISwitch FocusMotionS[2];
+        INumberVectorProperty *FocusTimerNP;
+        INumber FocusTimerN[1];
 
 };
